package com.maroontress.madangler.client.config;

import com.google.gwt.xml.client.Attr;
import com.google.gwt.xml.client.Document;
import com.google.gwt.xml.client.Element;
import com.google.gwt.xml.client.NamedNodeMap;
import com.google.gwt.xml.client.XMLParser;
import java.util.ArrayList;
import java.util.HashMap;

/**
   ץΥǥǤ
*/
public class ConfigModel {

    /** ץѥƥΥޥå */
    private HashMap propertyMap;

    /** ץåȥեΥޥå */
    private ArrayList platformSet;

    /** ѹΤꥹʤΥꥹ */
    private ArrayList listenerSet;

    /**
       Υץޤ
    */
    public ConfigModel() {
	propertyMap = new HashMap();
	platformSet = new ArrayList();
	listenerSet = new ArrayList();
    }

    /**
       ѹΤꥹʤɲäޤ

       @param listener ѹΤꥹ
    */
    public void addChangedListener(final ChangedListener listener) {
	listenerSet.add(listener);
    }

    /**
       ٤ƤΥꥹʤѹΤޤ
    */
    public void notifyChanged() {
	for (int k = 0; k < listenerSet.size(); ++k) {
            ChangedListener listener = (ChangedListener) listenerSet.get(k);
            listener.propertyChanged(this);
        }
    }

    /**
       ץѥƥͤޤ

       @param name ץѥƥ̾
       @return ץѥƥ
    */
    public String getProperty(final String name) {
	String s = (String) propertyMap.get(name);
	return (s == null) ? "" : s;
    }

    /**
       ץåȥեͤޤ

       @param k ץåȥեΥǥå
       @return ץåȥե
    */
    public Platform getPlatform(final int k) {
	return (Platform) platformSet.get(k);
    }

    /**
       IDꤷƥץåȥեͤޤ

       @param id ץåȥեID
       @return ץåȥե
    */
    public Platform getPlatformById(final String id) {
	int n = platformSet.size();
	for (int k = 0; k < n; ++k) {
	    Platform p = (Platform) platformSet.get(k);
	    if (p.getId().equals(id)) {
		return p;
	    }
	}
	return null;
    }

    /**
       ץåȥեθĿޤ

       @return ץåȥեθĿ
    */
    public int getPlatformSize() {
	return platformSet.size();
    }

    /**
       ץѥƥͤꤷޤ

       @param name ץѥƥ̾
       @param value ץѥƥ
    */
    public void setProperty(final String name, final String value) {
	propertyMap.put(name, value);
    }

    /**
       ץåȥեͤɲäޤ

       @param platform ץåȥե
    */
    public void addPlatform(final Platform platform) {
	platformSet.add(platform);
    }

    /**
       ץåȥեͤޤ

       @param k ץåȥեΥǥå
    */
    public void removePlatform(final int k) {
	platformSet.remove(k);
    }

    /**
       ץåȥեͤѹޤ

       @param k ץåȥեΥǥå
       @param platform ץåȥե
    */
    public void setPlatform(final int k, final Platform platform) {
	platformSet.set(k, platform);
    }

    /**
       ˤޤ
    */
    public void clear() {
	propertyMap.clear();
	platformSet.clear();
    }

    /**
       ץѥƥpropertyǤꤷޤ

       @param elem 
    */
    public void setPropertyElement(final Element elem) {
	NamedNodeMap map = elem.getAttributes();
	for (int k = 0; k < map.getLength(); ++k) {
	    Attr attr = (Attr) map.item(k);
	    propertyMap.put(attr.getName(), attr.getValue());
	}
    }

    /**
       ץåȥեplatformǤꤷޤ

       @param elem 
    */
    public void addPlatformElement(final Element elem) {
	platformSet.add(new Platform(elem));
    }

    /**
       XMLפ줿ʸޤ

       @param s ʸ
       @return XMLפ줿ʸ
    */
    private String escaped(final String s) {
	return s.replaceAll("&", "&amp;")
	    .replaceAll("<", "&lt;")
	    .replaceAll(">", "&gt;")
	    .replaceAll("\"", "&quot;");
    }

    /**
       ץXMLѴޤ

       @return XMLѴ줿ץ
    */
    public String getXML() {
	if (true) {
	    String xml = "";

	    xml += "<projectConfig>\n";
	    xml += "  <property";
	    Object[] key = propertyMap.keySet().toArray();
	    for (int k = 0; k < key.length; ++k) {
		String name = (String) key[k];
		String value = getProperty(name);
		xml += " " + name + "=\"" + escaped(value) + "\"";
	    }
	    xml += "/>\n";

	    int n = getPlatformSize();
	    for (int k = 0; k < n; ++k) {
		Platform p = getPlatform(k);
		xml += "  <platform id=\"" + escaped(p.getId())
		    + "\" host=\"" + escaped(p.getHost())
		    + "\" command=\"" + escaped(p.getCommand())
		    + "\" charset=\"" + escaped(p.getCharset())
		    + "\"/>\n";
	    }
	    xml += "</projectConfig>\n";
	    return xml;
	}
	/* GWT 1.5ʤޤϤξˤΥ꡼ǤϲΥɤư... */
	Document d = XMLParser.createDocument();
	Element root = d.createElement("projectConfig");
	Element elem;

	elem = d.createElement("property");
	Object[] key = propertyMap.keySet().toArray();
	for (int k = 0; k < key.length; ++k) {
	    String name = (String) key[k];
	    String value = getProperty(name);
	    elem.setAttribute(name, value);
	}
	root.appendChild(elem);

	int n = getPlatformSize();
	for (int k = 0; k < n; ++k) {
	    Platform p = getPlatform(k);
	    elem = d.createElement("platform");
	    p.exportAttributes(elem);
	    root.appendChild(elem);
	}

	d.appendChild(root);
	return d.toString();
    }
}
